function presjek = interPL(ravnina, pravac)
 
#{
interPL(ravnina, pravac) daje presjek ravnine i pravca.
---------------------------------------------------------------------------------
pravac -> struct("tocka", [x1 y1 z1], "vektor", [sx sy sz])
ravnina -> [A B C D]
na izlazu se vraca struktura koja sadrzi polja
"tocka" -> presjek pravca i ravnine
"t" -> parametar za koji se presjek dobiva iz parametarskih jednadžbi pravca
---------------------------------------------------------------------------------
pravac -> struct("tocka", [x1 y1 z1], "vektor", [sx sy sz])
ravnina -> struct("tocka", [x2,y2,z2], "vektorU", [u1,u2,u3], "vektorV", [v1,v2,v3])
na izlazu se vraca struktura koja sadrzi polja
"tocka" -> presjek pravca i ravnine
"u" i "v" -> parametri za koji se presjek dobiva iz parametarskih jednadzbi ravnine
"t" -> parametar za koji se presjek dobiva iz parametarskih jednadžbi pravca
#}

if !any(pravac.vektor)
  disp("Error: vektor smjera pravca je nulvektor");
  return;
endif  

if isstruct(ravnina)
  
  if !(any(ravnina.vektorU) & any(ravnina.vektorV))
    disp("Error: vektori koji razapinju ravninu ne smiju biti nulvektori");
    return;
  endif
  A = [ravnina.vektorU' ravnina.vektorV' -pravac.vektor'];
  B = (pravac.tocka - ravnina.tocka)';
  r0 = rank(A(:,1:2));
  r1 = rank(A);
  r2 = rank([A B]);
  if r0 != 2
    disp("Error: vektori koji razapinju ravninu ne smiju biti kolinearni");
    return;
  elseif r1 != r2
    disp("pravac i ravnina su paralelni");
    return;
  elseif r1 == 2
    disp("pravac se nalazi u ravnini");
    return;
  else
    rj = A \ B;
    prtoc = pravac.tocka + pravac.vektor .* repmat(rj(3), 1, 3);
    presjek = struct("u", rj(1), "v", rj(2), "t", rj(3), "tocka", prtoc);
  endif

else

  if !any(ravnina(1:3))
    disp("Error: normala ravnine je nulvektor");
    return;
  endif
  A = [[ravnina(1:3); eye(3)] [0 -pravac.vektor]'];
  B = [-ravnina(4); pravac.tocka'];
  r1 = rank(A);
  r2 = rank([A B]);
  if r1 != r2
    disp("pravac i ravnina su paralelni");
    return;
  elseif r1 == 3
    disp("pravac se nalazi u ravnini");
    return;
  else
    rj = A \ B;
    presjek = struct("tocka", rj(1:3)', "t", rj(4));
  endif

endif

endfunction
